package polytech.android.e6201;

import android.content.Intent;
import android.graphics.Color;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.TableLayout;

public class MainActivity extends AppCompatActivity implements View.OnClickListener {
    Button ex2Button;  // 課題2「背景色設定」
    Button ex3Button;  // 課題3「センサー」
    Button ex4Button;  // 課題4「サービス」
    Button ex5Button;  // 課題5「ネットワーク」

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        ex2Button = (Button) findViewById(R.id.ex2Button);
        ex3Button = (Button) findViewById(R.id.ex3Button);
        ex4Button = (Button) findViewById(R.id.ex4Button);
        ex5Button = (Button) findViewById(R.id.ex5Button);

        ex2Button.setOnClickListener(this);
        ex3Button.setOnClickListener(this);
        ex4Button.setOnClickListener(this);
        ex5Button.setOnClickListener(this);
    }

    @Override
    public void onClick(View v) {
        Intent intent = new Intent();
        switch (v.getId()) {
            case R.id.ex2Button:  // 背景色設定
                intent.setClass(this, SetColorActivity.class);
                startActivityForResult(intent, 0);
                break;
            case R.id.ex3Button:  // センサー
                intent.setClass(this, IlluminometerActivity.class);
                startActivity(intent);
                break;
            case R.id.ex4Button:  // サービス
                intent.setClass(this, NotificationActivity.class);
                startActivity(intent);
                break;
            case R.id.ex5Button:  // ネットワーク
                intent.setClass(this, NetActivity.class);
                startActivity(intent);
                break;
            default:
                /* NOT REACHED */
        }
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);

        TableLayout tableLayout = (TableLayout) findViewById(R.id.tableLayout);
        if (data != null) {
            tableLayout.setBackgroundColor(data.getIntExtra("checkedColor", Color.WHITE));
        }
    }
}
