package polytech.android.e6201;

import android.os.AsyncTask;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;
import android.widget.Toast;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.net.URL;
import java.net.URLConnection;

public class NetActivity extends AppCompatActivity {
    private static final String WEB_SERVER_ADDRESS = "http://www.jeed.or.jp/";
    private HtmlShowAsyncTask htmlShowAsyncTask;
    private TextView htmlTextView;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_net);

        htmlShowAsyncTask = new HtmlShowAsyncTask();
        htmlShowAsyncTask.execute(WEB_SERVER_ADDRESS);

        htmlTextView = (TextView) findViewById(R.id.htmlTextView);

        Button button = (Button) findViewById(R.id.backButton5);
        button.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                finish();
            }
        });
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();

        if (htmlShowAsyncTask != null) {
            htmlShowAsyncTask.cancel(true);
        }
    }

    class HtmlShowAsyncTask extends AsyncTask<String, Void, String> {
        @Override
        protected String doInBackground(String... params) {
            String result = null;

            try {
                // URLConnectionの作成
                URL url = new URL(params[0]);
                URLConnection con = url.openConnection();
                con.setDoOutput(true);  // 送信可能とする

                // 送信用ストリームの作成
                OutputStreamWriter ow = new OutputStreamWriter(con.getOutputStream());
                BufferedWriter bw = new BufferedWriter(ow);

                // 送信ストリームをクローズ
                bw.close();
                ow.close();

                // 受信する
                InputStreamReader ir = new InputStreamReader(con.getInputStream());
                BufferedReader br = new BufferedReader(ir);

                // 受信データをStringBuilderを利用して取得（改行挿入あり）
                StringBuilder stringBuilder = new StringBuilder();
                String line = null;
                while ((line = br.readLine()) != null) {
                    stringBuilder.append(line).append("\n");
                }

                // 受信ストリームをクローズ
                br.close();
                ir.close();

                return stringBuilder.toString();

            } catch (IOException e) {
                Log.e("<NetActivity>", e.toString());
                return e.toString();
            }
        }

        @Override
        protected void onPostExecute(String s) {
            super.onPostExecute(s);

            if (s != null) {
                htmlTextView.setText(s);
            }
        }
    }
}
