package polytech.android.e6201;

import android.app.Notification;
import android.app.NotificationManager;
import android.app.Service;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.os.IBinder;
import android.support.v7.app.NotificationCompat;

public class NotificationService extends Service implements Runnable {
    private boolean isTappedStopButton = false;  //「停止」ボタン（true:押した場合）

    @Override
    public IBinder onBind(Intent intent) {
        // TODO: Return the communication channel to the service.
        throw new UnsupportedOperationException("Not yet implemented");
    }

    @Override
    public int onStartCommand(Intent intent, int flags, int startId) {
        if ("show".equals(intent.getStringExtra("notification"))) {
            isTappedStopButton = false;

            // Notificationを5秒後に表示するタスクの作成と起動
            Thread thread = new Thread(this);
            thread.start();
        } else if ("hide".equals(intent.getStringExtra("notification"))) {
            isTappedStopButton = true;

            // NotificationManagerの取得と、表示したNotificationの消去
            NotificationManager manager = (NotificationManager) getSystemService(Service.NOTIFICATION_SERVICE);
            manager.cancel(0);
        }
        return START_NOT_STICKY;
    }

    @Override
    public void onDestroy() {
        super.onDestroy();
        isTappedStopButton = true;  //「戻る」ボタン → Notification動作させない
    }

    @Override
    public void run() {
        try {
            Thread.sleep(5000); //5sec
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        if (!isTappedStopButton) {  //「停止」ボタンが押されていない場合
            // LargeIconのBitmapを作成
            Bitmap largeIcon = BitmapFactory.decodeResource(getResources(), R.drawable.note_big);

            // NotificationBuilderを作成
            NotificationCompat.Builder builder = new NotificationCompat.Builder(getApplicationContext());

            // ステータスバーに表示されるテキスト
            builder.setTicker("５秒経過");
            // ステータスバーに表示されるアイコン
            builder.setSmallIcon(R.drawable.note_small);

            // Notificationを開いたときに表示されるタイトル
            builder.setContentTitle("お知らせ");
            // Notificationを開いたときに表示されるサブタイトル
            builder.setContentText("開始後、５秒が経過しました。");
            // Notificationを開いたときに表示されるアイコン
            builder.setLargeIcon(largeIcon);
            // 通知するタイミング
            builder.setWhen(System.currentTimeMillis());
            // 通知時の音・バイブ・ライト
            builder.setDefaults(Notification.DEFAULT_SOUND | Notification.DEFAULT_VIBRATE | Notification.DEFAULT_LIGHTS);
            // タップするとキャンセル(消える)
            builder.setAutoCancel(true);

            // NotificationManagerを取得
            NotificationManager manager = (NotificationManager) getSystemService(Service.NOTIFICATION_SERVICE);
            // Notificationを作成して通知
            manager.notify(0, builder.build());
        }
    }
}
