package polytech.android.e6201;

import android.app.Service;
import android.content.Intent;
import android.os.IBinder;

import java.util.Timer;
import java.util.TimerTask;

public class TimerService extends Service {
    static final String ACTION_TIME_LEFT = "polytech.android.e6201.ACTION_TIME_LEFT";
    private static int count;  // タイマーカウントダウンの現在値
    private Service thisService;
    Timer timer;

    @Override
    public void onCreate() {
        super.onCreate();

        thisService = this;
    }

    @Override
    public IBinder onBind(Intent intent) {
        // TODO: Return the communication channel to the service.
        throw new UnsupportedOperationException("Not yet implemented");
    }

    @Override
    public int onStartCommand(Intent intent, int flags, int startId) {
        count = intent.getIntExtra("countSecond", 0);  // タイマーのカウンタに値セット

        //Timerオブジェクトで別スレッドを扱う
        timer = new Timer();

        //タイマースケジュール設定＆開始
        timer.schedule(new TimerTask() {
            @Override
            public void run() {
                count--;  // 1秒毎にカウントダウン

                // ブロードキャストレシーバにカウント送信
                Intent actionIntent = new Intent(ACTION_TIME_LEFT);
                actionIntent.putExtra("count", count);
                sendBroadcast(actionIntent);

                if (count <= 0) {  // カウンタが0になったらサービスの停止
                    thisService.stopSelf();
                }
            }
        }, 1000, 1000);

        return START_NOT_STICKY;
    }

    @Override
    public void onDestroy() {
        super.onDestroy();
        timer.cancel();  //「ストップ」ボタン → タイマー停止
    }
}
